<?php
if ( ! defined( 'ABSPATH' ) ) exit;

add_filter( 'woocommerce_shop_order_search_fields', 'swyft_marketing_search_fields', 10, 1 );
function swyft_marketing_search_fields( $meta_keys ){
    $meta_keys[] = '_dvs_courier_list';
    $meta_keys[] = '_dvs_courier_tracking';
    return $meta_keys;
}

add_action( 'woocommerce_order_details_before_order_table', 'swyft_dvs_display_tracking_text_single_order', 10, 1 );
function swyft_dvs_display_tracking_text_single_order( $order ) {
    $dvs_courier_list = get_post_meta( $order->get_id(), '_dvs_courier_list', true );
    $dvs_courier_tracking = get_post_meta( $order->get_id(), '_dvs_courier_tracking', true );
    // Output Tracking box
    if( ! empty( $dvs_courier_list ) && $dvs_courier_list == 'Swyft Logistics' )
        echo '<p>Your order has been shipped via '. $dvs_courier_list .' and Tracking # is '. $dvs_courier_tracking .' . <a href="http://parceltracking.swyftlogistics.com/?'.$dvs_courier_tracking.'" target="blank" rel="no_follow">Get Live Tracking</a></p>';
}

add_filter( 'manage_edit-shop_order_columns', 'swyft_dvs_add_tracking_admin_list_column' );
function swyft_dvs_add_tracking_admin_list_column( $columns ) {
    $columns['dvs_show_tracking'] = 'Swyft Logistics';
    return $columns;
}

add_action( 'manage_shop_order_posts_custom_column', 'swyft_dvs_add_tracking_admin_list_column_content' );
function swyft_dvs_add_tracking_admin_list_column_content( $column ) {
    global $post;
    global $the_order;
    if ( 'dvs_show_tracking' === $column ) {
        $order = wc_get_order( $post->ID );
        $dvs_courier_list = get_post_meta( $order->get_id(), '_dvs_courier_list', true );
        $dvs_courier_tracking = get_post_meta( $order->get_id(), '_dvs_courier_tracking', true );
        if( ! empty( $dvs_courier_list ) && $dvs_courier_list == 'Swyft Logistics' ) {
        //    echo $dvs_courier_tracking;
            echo '<a href="http://parceltracking.swyftlogistics.com/?'.$dvs_courier_tracking.'" target="blank" rel="no_follow" style="font-size:12px">'.$dvs_courier_tracking.'</a>';
        }
    }
}






// Register Custom Order Status
add_filter( 'woocommerce_register_shop_order_post_statuses', 'swyft_dvs_new_custom_status' );
function swyft_dvs_new_custom_status( $order_statuses ){
    $order_statuses['wc-swyft'] = array(                                 
   'label'                     => _x( 'Booked at Swyft', 'Order status Booked at Swyft', 'woocommerce' ),
   'public'                    => true,                                 
   'exclude_from_search'       => false,                                 
   'show_in_admin_all_list'    => true,                                 
   'show_in_admin_status_list' => true,                                 
   'label_count'               => _n_noop( 'Booked at Swyft <span class="count">(%s)</span>', 'Booked at Swyft <span class="count">(%s)</span>', 'woocommerce' ),                              
   ); 
   return $order_statuses;
}

add_filter( 'wc_order_statuses', 'swyft_dvs_custom_single_order_list' );
function swyft_dvs_custom_single_order_list( $order_statuses ) {
    $order_statuses['wc-swyft'] = _x( 'Booked at Swyft', 'Order status', 'woocommerce' );
   return $order_statuses;
}

// add_filter( 'bulk_actions-edit-shop_order', 'swyft_dvs_custom_bulk_order_list' );
// function swyft_dvs_custom_bulk_order_list( $bulk_actions ) {
//     $bulk_actions['mark_swyft'] = 'Change status to Booked at Swyft';
//    return $bulk_actions;
// }


add_action('admin_head', 'swyft_dvs_custom_status_styling');
function swyft_dvs_custom_status_styling() {
echo '<style>
    .status-swyft {
        color: #000000;
        background: #ffffff;
        border: 1px solid #8d6dc4;
    }
</style>';
}
