<?php
if ( ! defined( 'ABSPATH' ) ) exit;

// Add Tracking meta box
add_action( 'add_meta_boxes', 'swyft_dvs_tracking_box' );
function swyft_dvs_tracking_box() {
    add_meta_box(
        'swyft_dvs-tracking-modal',
        'Swyft Logistics Details',
        'swyft_dvs_tracking_meta_box_callback',
        'shop_order',
        'side',
        'core'
    );
}

// Callback
function swyft_dvs_tracking_meta_box_callback( $post ) {
    $dvs_courier_list = get_post_meta($post->ID, '_dvs_courier_list', true);
    $dvs_courier_tracking = get_post_meta( $post->ID, '_dvs_courier_tracking', true );
	$dvs_courier_slip = get_post_meta( $post->ID, '_dvs_courier_slip', true );
    $dvs_courier_check = get_post_meta( $post->ID, '_dvs_courier_check', true );
    echo '<input type="hidden" name="swyft_dvs_tracking_box_nonce" value="' . wp_create_nonce() . '">';

    if( ! empty( $dvs_courier_list ) && $dvs_courier_list == 'Swyft Logistics' ) {

?>
    <select name="dvs_courier_check" id="dvs_courier_check" class="postbox">
        <option value="Un-Booked" <?php selected($dvs_courier_check, 'Un-Booked'); ?>>Un-Booked</option>
        <option value="Booked" <?php selected($dvs_courier_check, 'Booked'); ?>>Booked</option>            
    </select>

    <select name="dvs_courier_list" id="dvs_courier_list" class="postbox">
        <option value="">Select Courier</option>     
        <option value="Swyft Logistics" <?php selected($dvs_courier_list, 'Swyft Logistics'); ?>>Swyft Logistics</option>
    </select>

    <input style="width:100%;" type="text" name="dvs_courier_tracking" id="dvs_courier_tracking" placeholder="Tracking #" value="<?php echo $dvs_courier_tracking;?>"/>
    
    <?php
    if ($dvs_courier_tracking) {
       echo '<a href="http://parceltracking.swyftlogistics.com/?'.$dvs_courier_tracking.'" target="blank" rel="no_follow" class="woocommerce-Button button" style="width: 100%; text-align:center; margin: 20px 0px 0px 0px">View Tracking</a>'; 
        }

    }
}


add_action( 'save_post', 'swyft_dvs_tracking_save_meta_box_data' );
function swyft_dvs_tracking_save_meta_box_data( $post_id ) {
    if ( isset($_POST[ 'post_type' ]) && 'shop_order' != $_POST[ 'post_type' ] )
        return $post_id;
    if ( ! isset( $_POST[ 'swyft_dvs_tracking_box_nonce' ] ) )
        return $post_id;

    $nonce = $_POST[ 'swyft_dvs_tracking_box_nonce' ];
    if ( ! wp_verify_nonce( $nonce ) )
        return $post_id;
    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE )
        return $post_id;
    if ( ! current_user_can( 'edit_shop_order', $post_id ) && ! current_user_can( 'edit_shop_orders', $post_id ) )
        return $post_id;
    update_post_meta( $post_id, '_dvs_courier_list', sanitize_text_field( $_POST[ 'dvs_courier_list' ] ) );   
    update_post_meta( $post_id, '_dvs_courier_tracking', sanitize_text_field( $_POST[ 'dvs_courier_tracking' ] ) );  
    update_post_meta( $post_id, '_dvs_courier_check', sanitize_text_field( $_POST[ 'dvs_courier_check' ] ) );
}