<?php

add_action('woocommerce_order_actions', 'swyft_wc_order_action', 10, 1 );
function swyft_wc_order_action( $actions ) {
	if ( is_array( $actions ) ) {
		$actions['swyft_action'] = __( 'Book at Swyft Logistics' );
	}
	return $actions;
}

add_action( 'woocommerce_order_action_swyft_action', 'swyft_order_booking' );
function swyft_order_booking($order_id) {

    $dvs_swyft_note_check = get_option( 'dvs_swyft_note_check' );
    $dvs_swyft_product_check = get_option( 'dvs_swyft_product_check' );
	$dvs_swyft_sku_check = get_option( 'dvs_swyft_sku_check' );
	$dvs_swyft_weight_check = get_option( 'dvs_swyft_weight_check' );
	$dvs_swyft_pieces_check = get_option( 'dvs_swyft_pieces_check' );
	$dvs_swyft_cod_check = get_option( 'dvs_swyft_cod_check' );

    $count = 1;

    $order = wc_get_order($order_id);
    $orderData = $order->get_data();

    $order_number = $order->get_order_number();

    if( get_option('dvs_swyft_consignee') == 'Billing Details' ) {
		$name = $orderData['billing']['first_name'] . ' ' . $orderData['billing']['last_name'];
		$address = $orderData['billing']['address_1'] . ' ' . $orderData['billing']['address_2'];
		$city = $orderData['billing']['city'];
    }
    else {
		$name = $orderData['shipping']['first_name'] . ' ' . $orderData['shipping']['last_name'];
		$address = $orderData['shipping']['address_1'] . ' ' . $orderData['shipping']['address_2'];
		$city = $orderData['shipping']['city'];						          	
    }

	$email = $orderData['billing']['email']; 

	$phone = $orderData['billing']['phone'];
	$phone = str_replace(" ","",$phone);
	$phone = str_replace("-","",$phone);
	$phone = str_replace("+","",$phone);			          

    $remarks = '';
	if ($dvs_swyft_note_check == 1) {
		$remarks = get_option('dvs_swyft_remarks').' - '.$order->get_customer_note();
	}
	else {
		$remarks = get_option('dvs_swyft_remarks');
	}

	$details = '';
	$weight = 0;
	$pieces = 0;
	foreach ($order->get_items('line_item') as $item_id=>$item) {
		$product = $item->get_product();
		
		if ($dvs_swyft_product_check == 1 && $dvs_swyft_sku_check == 1) {
			$details .= ' [ '. $item['qty'] . ' x ' .$item['name'] . ' - '. $product->get_sku() . ' ] ';
		}
		else if($dvs_swyft_product_check == 1 ) {
			$details .= ' [ '. $item['qty'] . ' x ' .$item['name'] . ' ] ';
		}
		else {
    		$details = get_option( 'dvs_swyft_product' );
   		}
		if ($dvs_swyft_weight_check == 1) {
			$check_weight = $product->get_weight();
			if($check_weight) {
		    	$weight += $item['qty'] * $product->get_weight();
			}
			else {
				$weight = 0.5;
			}
		}
		else {
			$weight = 0.5;
		}

		if($weight < 0.5 ) {
			$weight = 0.5;
		}

		if ($dvs_swyft_pieces_check == 1 ) {
			$pieces += $item['qty'];
		}
		else {
    		$pieces = 1;
   		}

	}


	$remarks = get_option('dvs_swyft_remarks');
	if ($dvs_swyft_note_check == 1) {
		$remarks = $details .' - '. $remarks .' - '. $order->get_customer_note();
	}
	else {
		$remarks = $details .' - '. $remarks;
	}


	if ($dvs_swyft_cod_check == 1) {
		if($order->get_payment_method() == 'cod') {
			$amount = $orderData['total'];
		}
		else {
			$amount = 0;
		}
	}
	else {
		$amount = $orderData['total'];
	}
	
	$booking_data[] = array(
        'dvs_courier' => "SWYFT",		          		
		'id' => $orderData['id'], 		
		'count' => $count,
		'order' => $order->get_order_number(), 	
        'name' => $name,
        'address' => $address,
        'city' => $city,	        
        'phone' => $phone, 
        'email' => $email,
       	'amount' => $amount,
        'weight' => $weight,
        'pieces' => $pieces,
        'remarks' => $remarks,
		'type' => get_option('dvs_swyft_type'),
		'handling' => get_option('dvs_swyft_handling'),
	);

	if(empty($booking_data)) {
		echo 'Error: This order is already booked. Please change booking status to Un-booked from Woocommerce order page and try again.';
		die();
	}

	$body = json_encode($booking_data);

    $url = 'https://swyft-woo.devsol.org/woo/swyft/swyft.php';
    $output = wp_remote_post( $url, array('method'=> 'POST','sslverify' => false,'timeout'=> 300,'body'=> $body));
    if (is_wp_error($output)) {
        $error = $output->get_error_message();
        echo "Error: $error";
    }
    else {
        $json = $output['body'];
        echo $json;
    }
    die();
}