<?php

if ( ! defined( 'ABSPATH' ) ) exit;

//register plugin field settings
add_action( 'admin_init', 'official_swyft_plugin_settings' );
function official_swyft_plugin_settings() {
	register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_enable' );
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_vendor' );	
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_api' );
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_pickup' );     
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_origin' );
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_type' );     
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_handling' );           
	register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_consignee' );
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_products' );	      
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_remarks' );
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_note_check' );
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_product_check' );     
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_sku_check' );
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_weight_check' );    
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_pieces_check' );    
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_cod_check' );  
    register_setting( 'dvs-swyft-settings-group', 'dvs_swyft_status_check' );                                
}

//Courier settings input fields
function official_swyft_api_page() { ?>
<div class="wrap">
<form method="post" action="options.php">
    <?php 
	settings_fields( 'dvs-swyft-settings-group' );
	do_settings_sections( 'dvs-swyft-settings-group' ); 
	$dvs_swyft_type = get_option('dvs_swyft_type');
	$dvs_swyft_handling = get_option('dvs_swyft_handling');
	$dvs_swyft_consignee = get_option('dvs_swyft_consignee');
	$dvs_swyft_origin = get_option('dvs_swyft_origin');
 	?>
    <img src="<?php echo plugin_dir_url( __DIR__ ) . 'images/swyft-logo.png'; ?>">
    <h2>Swyft Settings</h2>
    <table class="form-table">

        <tr>
        <th scope="row">Enable Swyft Logistics API</th>
        <td>
	    <?php
	    echo '<input type="checkbox" name="dvs_swyft_enable" value="1" ' . checked( 1, get_option( 'dvs_swyft_enable' ), false ) . ' />';?>
        </td>
        </tr> 

        <tr>
        <th scope="row">Vendor ID</th>
        <td><input class="regular-text" placeholder="" type="text" name="dvs_swyft_vendor" value="<?php echo esc_attr( get_option('dvs_swyft_vendor') ); ?>" /></td>
        </tr>

        <tr>
        <th scope="row">API Secret</th>
        <td><input class="regular-text" placeholder="" type="password" name="dvs_swyft_api" value="<?php echo esc_attr( get_option('dvs_swyft_api') ); ?>" /></td>
        </tr>        

        <tr>
        <th scope="row">Pickup ID</th>
        <td><input class="regular-text" placeholder="" type="text" name="dvs_swyft_pickup" value="<?php echo esc_attr( get_option('dvs_swyft_pickup') ); ?>" /></td>
        </tr>       

        <tr>
        <th scope="row">Shipper Origin</th>
        <td>
			<select id="dvs_swyft_origin" name="dvs_swyft_origin" >
				<option value="LHE" <?php selected($dvs_swyft_origin,'LHE'); ?>>Lahore</option>
				<option value="KHI" <?php selected($dvs_swyft_origin,'KHI'); ?>>Karachi</option>
				<option value="ISB" <?php selected($dvs_swyft_origin,'ISB'); ?>>Islamabad</option>
				<option value="RWP" <?php selected($dvs_swyft_origin,'RWP'); ?>>Rawalpindi</option>
				<option value="SKP" <?php selected($dvs_swyft_origin,'SKP'); ?>>Sheikhupura</option>
				<option value="LYP" <?php selected($dvs_swyft_origin,'LYP'); ?>>Faisalabad</option>	
				<option value="KSR" <?php selected($dvs_swyft_origin,'KSR'); ?>>Kasur</option>
				<option value="GUJ" <?php selected($dvs_swyft_origin,'GUJ'); ?>>Gujranwala</option>
				<option value="SKT" <?php selected($dvs_swyft_origin,'SKT'); ?>>Sialkot</option>								
            </select>
        <td>        
        </tr>	        
 
        <tr>
        <th scope="row">Shipment Type</th>
        <td>
            <select id="dvs_swyft_type" name="dvs_swyft_type" >
            	<option value="COD" <?php selected($dvs_swyft_type,'COD'); ?>>COD</option>
            	<option value="NONCOD" <?php selected($dvs_swyft_type,'NONCOD'); ?>>NON COD</option>

            </select>
        <td>        
        </tr>

        <tr>
        <th scope="row">Default Handling</th>
        <td>
            <select id="dvs_swyft_handling" name="dvs_swyft_handling" >
            	<option value="Yes" <?php selected($dvs_swyft_handling,'Yes'); ?>>Fragile</option>
            </select>
        <td>        
        </tr>        

        <tr>
        <th scope="row">Consginee Details</th>
        <td>
            <select id="dvs_swyft_consignee" name="dvs_swyft_consignee" >
            <option value="Billing Details" <?php selected($dvs_swyft_consignee,'Billing Details'); ?>>Billing Details</option>
            <option value="Shipping Details" <?php selected($dvs_swyft_consignee,'Shipping Details'); ?>>Shipping Details</option>
            </select>
        <td>        
        </tr>

        <tr>
        <th scope="row">Remarks</th>
        <td><input class="regular-text" placeholder="" type="text" name="dvs_swyft_remarks" value="<?php echo esc_attr( get_option('dvs_swyft_remarks') ); ?>" /></td>
        </tr>  

        <tr>
        <th scope="row">Default Products</th>
        <td><input class="regular-text" placeholder="" type="text" name="dvs_swyft_products" value="<?php echo esc_attr( get_option('dvs_swyft_products') ); ?>" /></td>
        </tr>  

        <tr>
        <th scope="row">Print Item Name in Label</th>
        <td>
        <?php
        echo '<input type="checkbox" name="dvs_swyft_product_check" value="1" ' . checked( 1, get_option( 'dvs_swyft_product_check' ), false ) . ' />';?>
        </td>
        </tr>

        <tr>
        <th scope="row">Print SKU Name in Label</th>
        <td>
        <?php
        echo '<input type="checkbox" name="dvs_swyft_sku_check" value="1" ' . checked( 1, get_option( 'dvs_swyft_sku_check' ), false ) . ' />';?>
        </td>
        </tr>

        <tr>
        <th scope="row">Print Notes In Label</th>
        <td>
        <?php
        echo '<input type="checkbox" name="dvs_swyft_note_check" value="1" ' . checked( 1, get_option( 'dvs_swyft_note_check' ), false ) . ' />';?>
        </td>
        </tr>

        <tr>
        <th scope="row">Auto Calculate Weight</th>
        <td>
        <?php
        echo '<input type="checkbox" name="dvs_swyft_weight_check" value="1" ' . checked( 1, get_option( 'dvs_swyft_weight_check' ), false ) . ' />';?>
        </td>
        </tr>               

        <tr>
        <th scope="row">Auto Calculate Pieces</th>
        <td>
        <?php
        echo '<input type="checkbox" name="dvs_swyft_pieces_check" value="1" ' . checked( 1, get_option( 'dvs_swyft_pieces_check' ), false ) . ' />';?>
        </td>
        </tr>

        <tr>
        <th scope="row">Calculate Non-COD as Zero</th>
        <td>
        <?php
        echo '<input type="checkbox" name="dvs_swyft_cod_check" value="1" ' . checked( 1, get_option( 'dvs_swyft_cod_check' ), false ) . ' />';?>
        </td>
        </tr>

        <th scope="row">Add Swyft Order Status</th>
        <td>
        <?php
        echo '<input type="checkbox" name="dvs_swyft_status_check" value="1" ' . checked( 1, get_option( 'dvs_swyft_status_check' ), false ) . ' />';?>
        </td>
        </tr>  


    </table>

    <?php 	
	submit_button('Submit'); 
	?>
</form>

<br>
<a href="https://www.youtube.com/watch?v=wFJJLKVb1LI" target="blank" class="woocommerce-Button button">Video Tutorial</a>

<br>
<br>
<a href="https://devsol.pk/portal/support/" target="blank" class="woocommerce-Button button">Get Support</a>

</div>

<?php 
}


add_filter( 'bulk_actions-edit-shop_order', 'official_swyft_bulk_actions',101 );
function official_swyft_bulk_actions( $bulk_array ) {
	$dvs_swyft_enable = get_option( 'dvs_swyft_enable' );
	if ($dvs_swyft_enable == 1 ) {
		$bulk_array['mark_swyft_orders'] = 'Swyft Bulk Booking';
	}
	return $bulk_array;
}


add_filter( 'handle_bulk_actions-edit-shop_order', 'official_swyft_bulk_action_handler', 10, 4 );
function official_swyft_bulk_action_handler( $redirect, $doaction, $object_ids ) {
	 if ( $doaction !== 'mark_swyft_orders' ) {
	    return $redirect;
	}

    $dvs_swyft_note_check = get_option( 'dvs_swyft_note_check' );
    $dvs_swyft_product_check = get_option( 'dvs_swyft_product_check' );
	$dvs_swyft_sku_check = get_option( 'dvs_swyft_sku_check' );
	$dvs_swyft_weight_check = get_option( 'dvs_swyft_weight_check' );	
	$dvs_swyft_pieces_check = get_option( 'dvs_swyft_pieces_check' );
	$dvs_swyft_cod_check = get_option( 'dvs_swyft_cod_check' );	

    $count = 0;
    $skip = 0;

    foreach($object_ids as $order_id ) {
        $order = wc_get_order($order_id);
        $orderData = $order->get_data();

        if( $order->get_meta('_dvs_courier_check') == 'Booked' ) {
            $skip++;
            
            if( count($object_ids) == $count ) {
                wp_redirect( wp_get_referer() );
                die;
            }
            continue;
        }

        $count++;

        $postid = $order_id;

        $order_number = $order->get_order_number();

        if( get_option('dvs_swyft_consignee') == 'Billing Details' ) {
			$name = $orderData['billing']['first_name'] . ' ' . $orderData['billing']['last_name'];
			$address = $orderData['billing']['address_1'] . ' ' . $orderData['billing']['address_2'];
			$city = $orderData['billing']['city'];
        }
        else {
			$name = $orderData['shipping']['first_name'] . ' ' . $orderData['shipping']['last_name'];
			$address = $orderData['shipping']['address_1'] . ' ' . $orderData['shipping']['address_2'];
			$city = $orderData['shipping']['city'];						          	
        }

		$email = $orderData['billing']['email'];

		if(empty($email)) {
			$email = 'user@user.com';
		}

		$phone = $orderData['billing']['phone'];
		$phone = str_replace(" ","",$phone);
		$phone = str_replace("-","",$phone);
		$phone = str_replace("+","",$phone);			          

        $remarks = '';
		if ($dvs_swyft_note_check == 1) {
			$remarks = get_option('dvs_swyft_remarks').' - '.$order->get_customer_note();
		}
		else {
			$remarks = get_option('dvs_swyft_remarks');
		}

		$details = '';
		$weight = 0;		
		$pieces = 0;
		foreach ($order->get_items('line_item') as $item_id=>$item) {
			$product = $item->get_product();
			
			if ($dvs_swyft_product_check == 1 && $dvs_swyft_sku_check == 1) {
				$details .= ' [ '. $item['qty'] . ' x ' .$item['name'] . ' - '. $product->get_sku() . ' ] ';
			}
			else if($dvs_swyft_product_check == 1 ) {
				$details .= ' [ '. $item['qty'] . ' x ' .$item['name'] . ' ] ';
			}
			else {
        		$details = get_option( 'dvs_swyft_products' );
       		}

			if ($dvs_swyft_weight_check == 1) {
				$check_weight = $product->get_weight();
				if($check_weight) {
			    	$weight += $item['qty'] * $product->get_weight();
				}
				else {
					$weight = 0.5;
				}
			}
			else {
				$weight = 0.5;
			}

			if($weight < 0.5 ) {
				$weight = 0.5;
			}       		

			if ($dvs_swyft_pieces_check == 1 ) {
				$pieces += $item['qty'];
			}
			else {
        		$pieces = 1;
       		}
		}

		$remarks = get_option('dvs_swyft_remarks');
		if ($dvs_swyft_note_check == 1) {
			$remarks = $details .' - '. $remarks .' - '. $order->get_customer_note();
		}
		else {
			$remarks = $details .' - '. $remarks;
		}


		if ($dvs_swyft_cod_check == 1) {
			if($order->get_payment_method() == 'cod') {
				$amount = $orderData['total'];
			}
			else {
				$amount = 0;
			}
		}
		else {
			$amount = $orderData['total'];
		}
		
    	$booking_data[] = array(
	        'dvs_courier' => "SWYFT",		          		
   			'id' => $order_id, 		
    		'count' => $count,
			'order' => $order->get_order_number(), 	
	        'name' => $name,
	        'address' => $address,
	        'city' => $city,	        
	        'phone' => $phone, 
	        'email' => $email,
	       	'amount' => $amount,
	        'weight' => $weight,
	        'pieces' => $pieces,
	        'remarks' => $remarks,
			'type' => get_option('dvs_swyft_type'),
			'handling' => get_option('dvs_swyft_handling'),
    	);
	}

	if(empty($booking_data)) {
		echo 'Error: This order is already booked. Please change booking status to Un-booked from Woocommerce order page and try again.';
		die();
	}	

	$body = json_encode($booking_data);

    $url = 'https://swyft-woo.devsol.org/woo/swyft/swyft.php';
    $output = wp_remote_post( $url, array('method'=> 'POST','sslverify' => false,'timeout'=> 300,'body'=> $body));
    if (is_wp_error($output)) {
        $error = $output->get_error_message();
        echo "Error: $error";
    }
    else {
        $json = $output['body'];
        echo $json;
    }
}


add_action( 'init', 'official_swyft_submit_form' );
function official_swyft_submit_form() {    
    if( !empty($_POST['courier']) && $_POST['courier'] == 'SWYFT') {

    	$orders = $_POST['order'];
    	$msgs = '';
		$count = 0;
		$uncount = 0;
		$actualcount = 0;		
		$allcount = 1;

		foreach($orders as $order) {

		    if(!isset($order['check']))
		    continue;
			
			$book_packet_array = array(
				'dvs_courier' => "SWYFT",
				'dvs_swyft_vendor' => get_option('dvs_swyft_vendor'),				
				'dvs_swyft_api' => get_option('dvs_swyft_api'),
				'dvs_swyft_origin'	=>  get_option('dvs_swyft_origin'),				
				'dvs_swyft_pickup'	=>  get_option('dvs_swyft_pickup'),
				'order' => $order,
			);

            $booking = json_encode($book_packet_array);

            $url = 'https://swyft-woo.devsol.org/woo/upload.php';
            $output = wp_remote_post( $url, array('method'=> 'POST','sslverify' => false,'timeout'=> 300,'body'=> $booking));
            if ( is_wp_error( $output ) ) {
                $error = $output->get_error_message();
                echo "Error: $error";
            }
            else {
                $json = $output['body'];
                $response = json_decode($json,true);
            }

            $order_id = $order['id'];

			if (!empty($response['data'][0]['parcelId'])) {

				$swyft_tracking = $response['data'][0]['parcelId'];

				$swyft_trackings .= $swyft_tracking . ','; 

	    		$msgs .= "<div style='background-color:#107f61; color:#fff; padding:5px 10px; border: 1px solid #107f61;'><strong>${allcount}: </strong>Order # ".$order['order'];
				$msgs .= "<span> [ Booked: ".$swyft_tracking." ]</span></div>";

				$order = new WC_Order($order_id);

				$order->add_order_note("Order has been booked at Swyft Logistics with Tracking # ".$swyft_tracking);

				$dvs_swyft_status_check = get_option( 'dvs_swyft_status_check' );

				if ($dvs_swyft_status_check == 1) {
					$order->update_status( 'wc-swyft' );
				}				

				update_post_meta( $order->get_id(), '_dvs_courier_list', 'Swyft Logistics');   
	    		update_post_meta( $order->get_id(), '_dvs_courier_tracking', $swyft_tracking );
	    		update_post_meta( $order->get_id(), '_dvs_courier_check', 'Booked' );

	    		$count++;
	    	}
			else {
				$msgs .= "<div style='background-color:#ff4e4e; color:#fff; padding:5px 10px; border: 1px solid #ffffff;'><strong>${allcount}: </strong>Order # ".$order['order'];
				$msgs .= "<span> [ Error: ".$json." ]</span></div>";

			//	$order_id = $order['id'];
			//	$order = new WC_Order($order_id);
			//	update_post_meta( $order->get_id(), '_dvs_courier_check', 'Un-Booked' );
				$uncount++;
			}

			$allcount++;
			$actualcount++;
		}	

		if($msgs!='') { ?>

		<style>
		@import url('https://fonts.googleapis.com/css2?family=Roboto&display=swap');

		h3 {
			text-align: center;
		}

		.dvs-booking-result {
			width: 600px;
			margin: 0 auto;
			font-family: 'Roboto', sans-serif;
			margin-top: 20px;
		}				

		.dvs-btn-back {
			float:  right;
		    border: 1px solid #107f61;
		    border-radius: 2px;
		    padding: 10px 20px;
		    text-align: center;
		    text-decoration: none;
		    background-color: #ffffff;
		    color: #107f61;
		    font-size: 16px;		
		}

		.dvs-btn-print {
			float: left;
		    border: 1px solid #107f61;
		    border-radius: 2px;
		    padding: 10px 20px;
		    text-align: center;
		    text-decoration: none;
		    background-color: #107f61;
		    color: #ffffff;
		    font-size: 16px;		
		}			

		</style>

		<?php
			echo '<div class="dvs-booking-result">';?>
			<center>	
			<img src="<?php echo plugin_dir_url( __DIR__ ) . 'images/swyft-logo.png'; ?>">	
			<h3>Swyft Booking Summary</h3>
			</center>
			<?php 
			echo "Booked Packets = ${count}";
			echo '<br/>';
			echo '<br/>';		
			echo "Un-Booked Packets = ${uncount}";
			echo '<br/>';
			echo '<br/>';
			echo $msgs;
			echo '<br/>';
			echo '<br/>';

			if($_SERVER['REQUEST_URI'] == '/wp-admin/post.php') {
				$btn_url = get_admin_url(null, 'post.php?post='.$order_id.'&action=edit');
			}
			else {
				$btn_url = get_admin_url(null, 'edit.php?post_type=shop_order');
			}

			$swyft_trackings = rtrim($swyft_trackings, ',');

			$curl = curl_init();
			curl_setopt_array($curl, array(
			  CURLOPT_URL => 'https://api.swyftlogistics.com:3000/api/'.get_option("dvs_swyft_vendor").'/api-get-standard-label-urls?parcel_ids='.$swyft_trackings.'&response_type=pdf',
			  CURLOPT_RETURNTRANSFER => true,
			  CURLOPT_ENCODING => '',
			  CURLOPT_MAXREDIRS => 10,
			  CURLOPT_TIMEOUT => 0,
			  CURLOPT_FOLLOWLOCATION => true,
			  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			  CURLOPT_CUSTOMREQUEST => 'GET',
			  CURLOPT_HTTPHEADER => array(
			    'Authorization: '.get_option("dvs_swyft_api")
			  ),
			));
			$response = curl_exec($curl);
			curl_close($curl);
			$result = json_decode($response, true);

			if($result['url']) {
				echo '<a href="'.$result['url'].'" class="dvs-btn-print">Download Labels</a>';
			}
			echo '<a href="'.$btn_url.'" class="dvs-btn-back">Go Back</a>';
			echo '</div>';
		}

		$url = "https://swyft-woo.devsol.org/woo/count.php";
		$data_count = array(
			'dvs_courier' => 'SWYFT',
			'count' => $actualcount,
			'booked' => $count,
			'unbooked' => $uncount,
		);
		$data_count = json_encode($data_count);
		$post = wp_remote_post( $url, array('method'=> 'POST','sslverify' => false,'timeout'=> 30, 'body'=> $data_count ));
		die();   
    }
}

