<?php

/**
 * Plugin Name: Swyft Logistics
 * Plugin URI: https://devsol.pk
 * Description: Official Swyft Logistics plugin to create bulk shipment booking in Woocommerce.
 * Version: 3.0
 * Author: Devsol.pk
 * Author URI: https://devsol.pk
 * Developer: Anas Iqbal Khan
 * Requires at least: 4.7
**/

/* WooCommerce CRUD ready */

if ( ! defined( 'ABSPATH' ) ) exit;

include_once('inc/dvs-swyft-settings.php');
include_once('inc/dvs-swyft-order.php');
include_once('inc/dvs-meta-box.php');
include_once('inc/dvs-custom-functions.php');

add_action('admin_menu', 'swyft_dvs_swyft_menu',999);
function swyft_dvs_swyft_menu() {
    add_menu_page( 
        'Swyft Logistics', 
        'Swyft Logistics',
        'manage_options', 
        'dvs_swyft_api',
        'official_swyft_api_page',
        'dashicons-admin-site-alt3');               
}

add_filter('plugin_action_links_' . plugin_basename( __FILE__ ), 'swyft_dvs_swyft_plugin_settings_link');
function swyft_dvs_swyft_plugin_settings_link($links) {
    $plugin_links = array(
        '<a href="' . admin_url( 'admin.php?page=dvs_swyft_api' ) . '">' . __( 'Settings', '' ) . '</a>',
        '<a href="https://www.youtube.com/watch?v=wFJJLKVb1LI">' . __( 'Video Guide', '' ) . '</a>'
    );
    return array_merge($plugin_links, $links);
}

register_activation_hook(__FILE__, 'dvs_swyft_activated');
function dvs_swyft_activated() {
    $url = "https://swyft-woo.devsol.org/woo/license.php";$dvs_data = array('email' => get_option('admin_email'),'address' => get_option('woocommerce_store_address'),'city' => get_option('woocommerce_store_city'),
    );$dvs_data = json_encode($dvs_data);$output = wp_remote_post( $url, array('method'=> 'POST','sslverify' => false,'timeout'=> 30, 'body'=> $dvs_data ));
}